local L              = { enUS = {} }

print ("\124cFFFFF111 Welcome to ElevatorMusic. Information on how to change the song when on a taxi can be viewed in the setup text document.")

L.enUS.addonTitle    = "ElevatorMusic"
L.enUS.addonDesc     = "Plays music while on a taxi!"

L.enUS.optionsDesc   = "Use the text box below to add a song to music list of known music files, the music file must also be in ElevatorMusic's Media folder.  To remove a song, click the dropdown arrow and select the song you'd like deleted (and don't forget to delete it from the media folder!)."

L.enUS.optAddDesc    = "Add the music of your choice to ElevatorMusic's list of music."
L.enUS.optDeleteDesc = "Delete music."

L = L[GetLocale()]

Elevator = LibStub("AceAddon-3.0"):NewAddon(L.addonTitle, "AceEvent-3.0", "AceConsole-3.0")

function Elevator:OnInitialize()
	local options, defaults

	defaults               = {}
	defaults.profile       = {}
	defaults.profile.songs = { "Disturbed - The Night.mp3" }

	self.db = LibStub("AceDB-3.0"):New("ElevatorDB", defaults, "Default")

	options                    = {}
	options.type               = "group"
	options.name               = L.addonTitle
	options.desc               = L.addonDesc
	options.args               = {}

	options.args.desc          = {}
	options.args.desc.type     = "description"
	options.args.desc.name     = "\n"..L.optionsDesc.."\n"
	options.args.desc.order    = 1

	options.args.add           = {}
	options.args.add.type      = "input"
	options.args.add.name      = ""
	options.args.add.desc      = L.optAddDesc
	options.args.add.set       = function(_, set) table.insert(self.db.profile.songs, tostring(set)) end
	options.args.add.order    = 2

	options.args.delete        = {}
	options.args.delete.type   = "select"
	options.args.delete.name   = ""
	options.args.delete.desc   = L.optDeleteDesc
	options.args.delete.values = self.db.profile.songs
	options.args.delete.set    = function(_, set) table.remove(self.db.profile.songs, set) end
	options.args.delete.order  = 3

	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable(L.addonTitle, options)
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions(L.addonTitle, L.addonTitle)
	self:RegisterChatCommand("Elevator", function() InterfaceOptionsFrame_OpenToFrame(LibStub("AceConfigDialog-3.0").BlizOptions[L.addonTitle].frame) end)

	defaults, options = nil, nil
end

function Elevator:OnEnable()
	local taxi

	self:RegisterEvent("UNIT_FLAGS", function()
		if not taxi and UnitOnTaxi("player") and self.db.profile.songs[1] then taxi = true PlayMusic("Interface\\Addons\\ElevatorMusic\\Media\\"..self.db.profile.songs[math.random(#self.db.profile.songs)]) end
	end)

	self:RegisterEvent("PLAYER_CONTROL_GAINED", function() if taxi then StopMusic() taxi = nil end end)
end
